#include "ofApp.h"

void ofApp::setup(){
    ofBackground(0);
    ofSetFrameRate(30);
    ROWS = 80;
    COLS = ROWS;
    GRIDX = float(ofGetScreenWidth() / COLS);
    GRIDY = float(ofGetScreenHeight() / ROWS);
    ofSetLineWidth(2);
    percent=1;
    p1.set(0, -GRIDY*percent);
    p2.set(0, GRIDY*percent);
}

void ofApp::update(){
}

void ofApp::draw(){
    for (int rows=0; rows<ROWS; rows++) {
            for (int cols=0; cols<COLS; cols++) {
                ofPushMatrix();
                posX = cols * GRIDX - GRIDX/2;
                posY = rows * GRIDY + GRIDY/2;
                ofTranslate(posX, posY);
                dx = posX - mouseX;
                dy = posY - mouseY;
                angle = atan2(dy, dx);
                ofRotateZ(angle * RAD_TO_DEG + 90);
                //ofRotateZ(ofGetFrameNum());
                ofLine(p1,p2);
                ofPopMatrix();
            }
    }
}

void ofApp::keyPressed(int key){
    if (key == 's') {
        glReadBuffer(GL_FRONT);  // HACK for windows
        ofSaveScreen("savedScreenshot_"+ofGetTimestampString()+".png");
    }
}
