#include "ofApp.h"

void ofApp::setup(){
    ofBackground(255,255,255);
    glEnable(GL_DEPTH_TEST);
    //glEnable(GL_BLEND);
    //glBlendFunc(GL_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glAlphaFunc(GL_GREATER, 0.5) ;
    glEnable(GL_ALPHA_TEST) ;

    font.loadFont("Batang.ttf", 24, true, true, true);
    ttfChar = font.getCharacterAsPoints('C');
    ofSetFullscreen(false);
    angle = 0.0;

    // Fichier de mots
    ifstream infile;
    infile.open("./data/miserables.txt");
    if (!infile) cout << "can't open file" << endl;
    string w;
    while (infile >> w) {
        words.push_back(w);
        positions.push_back(ofPoint(ofRandom(0,700)-350,
                                    ofRandom(0,700)-350,
                                    ofRandom(0,700)-350));
    }
}

bool wordIsTooHip(string w) {
    if (w == "a") return true; // caractère en rouge
    else    return false;
}

void ofApp::update(){
    // Brownian motion
    for (int i = 0; i < words.size(); i++) {
        positions[i].x += ofRandom(-1,1);
        positions[i].y += ofRandom(-1,1);
    }
}

void ofApp::draw(){
    ofFill();
    camera.begin();
    ofPushMatrix();
        for (int i = 0; i<  words.size(); i=i+1) {
            ofPushMatrix();
            ofTranslate(positions[i]);
            if ( wordIsTooHip(words[i]) ) ofSetColor(255,0,0);
            else ofSetColor(0,0,0);
            font.drawString(words[i], 0.0, 0.0);
            ofPopMatrix();
        }
    ofPopMatrix();
    camera.end();
}
