// From Fleeing Triangle Brush : ofBook (https://github.com/openframeworks/ofBook).
// Copyright (c) 2014 Michael Hadley, mikewesthad.com

#include "ofApp.h"

void ofApp::setup(){
    ofSetFrameRate(60);
    ofSetBackgroundAuto(false);
    ofBackground(0);
}

void ofApp::update(){
}

void ofApp::draw(){
    if (ofGetMousePressed(OF_MOUSE_BUTTON_LEFT)) {
        int numTriangles = 10;
        int minOffset = 5;
        int maxOffset = 70;
        int alpha = 150;

        for (int t=0; t<numTriangles; ++t) {

            float offsetDistance = ofRandom(minOffset, maxOffset);  // Distance
            ofVec2f mousePos(ofGetMouseX(), ofGetMouseY()); // Mouse

            //Triangle at the origin (0,0) that points to the right
            ofVec2f p1(0, 6.25);
            ofVec2f p2(25, 0);
            ofVec2f p3(0, -6.25);

            // Rotation degrees
            float rotation = ofRandom(360);
            p1.rotate(rotation);
            p2.rotate(rotation);
            p3.rotate(rotation);
            ofVec2f triangleOffset(offsetDistance, 0.0);
            triangleOffset.rotate(rotation);

            p1 += mousePos + triangleOffset;
            p2 += mousePos + triangleOffset;
            p3 += mousePos + triangleOffset;

            ofColor aqua(0, 252, 255, alpha);
            ofColor purple(198, 0, 205, alpha);
            ofColor inbetween = aqua.getLerped(purple, ofRandom(1.0));
            ofSetColor(inbetween);

            ofTriangle(p1, p2, p3);
        }
    }
    if (ofGetMousePressed(OF_MOUSE_BUTTON_RIGHT)) {
        ofBackground(0);  // Erase the screen with a black background
    }
}

void ofApp::keyPressed(int key){
    if (key == 's') {
        glReadBuffer(GL_FRONT);  // HACK for windows
        ofSaveScreen("savedScreenshot_"+ofGetTimestampString()+".png");
    }
}
